# CloneShaderNodePlugin
# Initial code generated by Softimage SDK Wizard
# Executed Wed Jan 28 11:42:34 UTC+0100 2015 by 3D1
# 
# Tip: To add a command to this plug-in, right-click in the 
# script editor and choose Tools > Add Command.

### Import Definitions

import win32com.client
from win32com.client import constants as si
from win32com.client import constants


null = None
false = 0
true = 1


def XSILoadPlugin( in_reg ):
	in_reg.Author = "jd"
	in_reg.Name = "CloneShaderNodePlugin"
	in_reg.Major = 1
	in_reg.Minor = 0

	in_reg.RegisterCommand("CloneShaderNode","CloneShaderNode")
	in_reg.RegisterMenu(constants.siMenuRTNodeContextID,"CloneShaderNode_Menu",false,false)
	#in_reg.RegisterMenu(constants.siMenuICENodeContextID,"CloneShaderNode_Menu",false,false)
	#RegistrationInsertionPoint - do not remove this line

	return true

def XSIUnloadPlugin( in_reg ):
	strPluginName = in_reg.Name
	Application.LogMessage(str(strPluginName) + str(" has been unloaded."),constants.siVerbose)
	return true

def CloneShaderNode_Init( in_ctxt ):
	oCmd = in_ctxt.Source
	oCmd.Description = ""
	oCmd.ReturnValue = true

	return true

def CloneShaderNode_Execute(  ):

	### Simplify Commands

	a = Application

	### Init Undo

	a.BeginUndo("Clone Shader")

	### Get The Active View

	oLayout = a.Desktop.ActiveLayout
	oRTViews = oLayout.Views.Filter( "Render Tree" )

	x = oRTViews(0)
	y = x.GetAttributeValue( "selection" ).split(",")

	### Set up a dictionary to return shader parameter types

	shaderparamtypes = {
			"-1":"siShaderDataTypeUnknown", "0":"siShaderDataTypeBoolean", "1":"siShaderDataTypeInteger",
			"2":"siShaderDataTypeScalar", "3":"siShaderDataTypeVector2", "4":"siShaderDataTypeVector3",
			"5":"siShaderDataTypeVector4", "6":"siShaderDataTypeQuaternion", "7":"siShaderDataTypeMatrix33",
			"8":"siShaderDataTypeMatrix44", "9":"siShaderDataTypeColor3", "10":"siShaderDataTypeColor4",
			"11":"siShaderDataTypeString", "16":"siShaderDataTypeProperty", "17":"siShaderDataTypeProfileCurve",
			"18":"siShaderDataTypeGradient", "32":"siShaderDataTypeReference", "33":"siShaderDataTypeImage",
			"48":"siShaderDataTypeCustom", "64":"siShaderDataTypeStructure", "65":"siShaderDataTypeArray"
	}

	### Get The Shader Parameters

	a.SelectObj(y, "", "")

	oNode = a.Selection(0)
	oNodeName = oNode.Name
	oNodeID = oNode.ProgID
	oMaterial = oNode.Parent

	#print oNode
	#print oNodeID
	#print oMaterial

	### Clone Shader Node

	oNodeClone = Application.CreateShaderFromProgID( oNodeID, oMaterial, str(oNodeName) + "_Clone1")

	#print oNodeClone.Name

	### CopyPaste Parameters from Source to Clone Node

	for i in oNode.Parameters : 
		oNodeParameterType = oNode.GetShaderParameterType( i.ScriptName )
		for ii in oNodeParameterType :
			if ii == True :
				#print i
				if (i.IsClassOf(si.siShaderParameterID)) :
					#print "'" + i.ScriptName + "' == " + shaderparamtypes[str(i.DataType)]
					oPType = shaderparamtypes[str(i.DataType)]
					pars = str(i)
					parC = str(oNodeClone) + "." + str(i.Name)
					#print str(i.type) + "*****************************"
					#print oPType
					#print i.source
					if i.Name == "Name":
						print str(i.Name) + " IS NOT WANTED AND HAS NO VALUE "
					#if i.Name == "ambience":
					#	print str(i.Name) + " IS NOT WANTED AND HAS NO VALUE "
					elif i.Name == "lights":
						print str(i.Name) + " IS LIGHT LIST -- TAKE CARE OF "
					elif i.Name == "out":
						print str(i.Name) + " IS OUTPUT "
					elif oPType == "siShaderDataTypeBoolean":
						Application.CopyPaste(pars, "", parC, 0)
						#print str(i.Name) +  " - I'M BOOLEAN"
					elif oPType == "siShaderDataTypeScalar":
						Application.CopyPaste(pars, "", parC, 0)
						#print str(i.Name) +  " - I'M SCALAR"
					elif oPType == "siShaderDataTypeInteger":
						Application.CopyPaste(pars, "", parC, 0)
						#print str(i.Name) +  " - I'M INTEGER"
					elif oPType == "siShaderDataTypeProperty":
						#Application.CopyPaste(pars, "", parC, 0)
						print str(i.Name) +  " - I'M PROPERTY"
					elif oPType == "siShaderDataTypeVector3":
						Application.CopyPaste(str(i) + ".x", "" , str(parC) + ".x", 1)
						Application.CopyPaste(str(i) + ".y", "" , str(parC) + ".y", 1)
						Application.CopyPaste(str(i) + ".z", "" , str(parC) + ".z", 1)
						#print str(i.Name) +  " - I'M VECTOR3"
					elif oPType == "siShaderDataTypeColor3":
						Application.CopyPaste(str(i) + ".red", "" , str(parC) + ".red", 1)
						Application.CopyPaste(str(i) + ".green", "" , str(parC) + ".green", 1)
						Application.CopyPaste(str(i) + ".blue", "" , str(parC) + ".blue", 1)
						#print str(i.Name) +  " - I'M COLOR3"
					elif oPType == "siShaderDataTypeColor4":
						Application.CopyPaste(str(i) + ".red", "" , str(parC) + ".red", 1)
						Application.CopyPaste(str(i) + ".green", "" , str(parC) + ".green", 1)
						Application.CopyPaste(str(i) + ".blue", "" , str(parC) + ".blue", 1)
						Application.CopyPaste(str(i) + ".alpha", "" , str(parC) + ".alpha", 1)
						#print str(i.Name) +  " - I'M COLOR4"
					else:
						#Application.CopyPaste(pars, "", parC, 0)
						print str(i.Name) +  " - *** Do everything else ***" + str(oPType)


	### COPY INPUT CONNETCTIONS




	### Exit Undo

	a.EndUndo()

def CloneShaderNode_Menu_Init( in_ctxt ):
	oMenu = in_ctxt.Source
	oMenu.AddCommandItem("Clone Node","CloneShaderNode")
	return true

